.nolist
COMMENT @ inspired by http://www.masm32.com/board/index.php?topic=6181.15
The procedure InstrCi performs a case-insensitive search @
    .686
    .MODEL FLAT,STDCALL
    OPTION CASEMAP:NONE
  
    include \masm32\include\windows.inc
    include \masm32\macros\timers.asm      
    include \masm32\macros\macros.asm    
    include \masm32\include\kernel32.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\msvcrt.inc
    include \masm32\include\shlwapi.inc

    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\msvcrt.lib
    includelib \masm32\lib\shlwapi.lib

    InStringL	PROTO :DWORD, :DWORD
    InstrCi	PROTO :DWORD, :DWORD
    finstr	PROTO :DWORD, :DWORD, :DWORD

; 

.data
Mainstr	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot "
	db "and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot "
	db "and whether pigs have wings ", 0

Substrx	db "wings", 0
SubstrxCi	db "Wings", 0

cl1 dd 0
cl2 dd 0
cl3 dd 0
cl4 dd 0
cl5 dd 0

.data?
res1	dd ?
res2	dd ?
res3	dd ?
res4	dd ?
res5	dd ?

.code
start:

; 

NumLoops EQU 10000

  REPEAT 8

    LOOP_COUNT EQU NumLoops 
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke crt_strstr,addr Mainstr,addr Substrx
    mov res1, eax
    counter_end
    add cl1, eax
    print str$(eax)," timing crt_strstr",13,10

    LOOP_COUNT EQU NumLoops 
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke finstr,0,addr Mainstr,addr Substrx
    mov res2, eax
    counter_end
    add cl2, eax
    print str$(eax)," timing finstr",13,10

    LOOP_COUNT EQU NumLoops 
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke InStringL,addr Mainstr,addr Substrx
    mov res3, eax
    counter_end
    add cl3, eax
    print str$(eax)," timing InStringL",13,10

    LOOP_COUNT EQU NumLoops 
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke InstrCi, addr Mainstr, addr SubstrxCi
    mov res4, eax
    counter_end
    add cl4, eax
    print str$(eax)," timing InstrCi",13,10

    LOOP_COUNT EQU NumLoops
    counter_begin LOOP_COUNT/100, HIGH_PRIORITY_CLASS
    invoke StrStrI, addr Mainstr, addr SubstrxCi
    mov res5, eax
    counter_end
    add cl5, eax
    print str$(eax)," timing StrStrI",13,10, 13, 10
   
  ENDM

    shr cl1, 3
    shr cl2, 3
    shr cl3, 3
    shr cl4, 3
    shr cl5, 3

    print "----------------------",13,10
    print str$(cl1)," average crt_strstr",9, "res="
    print str$(res1),13,10
    print str$(cl2)," average finstr",9, "res="
    print str$(res2),13,10
    print str$(cl3)," average InStringL",9, "res="
    print str$(res3),13,10
    print str$(cl4)," average InstrCi",9, "res="
    print str$(res4),13,10
    print str$(cl5)," average StrStrI",9, "res="
    print str$(res5),13,10
    print "----------------------",13,10

    inkey

invoke ExitProcess, 0

; 
OPTION PROLOGUE:NONE			; turn it off
OPTION EPILOGUE:NONE			;
align 16						;
InStringL	proc lpSource:DWORD, lpPattern:DWORD
	mov		eax, [esp+1*4]		; eax-> lpSource
    mov		edx, [esp+2*4]		; edx->lpPattern
    movzx	ecx, byte ptr [edx] ; ecx->the 1st byte of substring
	mov		[esp+2*4], esi		; saving register esi
    imul	ecx, 1010101h       ; ecx=77 77 77 77h  ; 77h -> ASCII code of "w"
	mov		[esp+1*4], ebx		; saving register ebx
	lea		esi, [edx+1]		; esi->lp Pattern +1
BytesScan:						;
	mov		edx, ecx			; edx=77 77 77 77h  ; 77h -> ASCII code of "w"
	xor		ebx, ebx			;
@@:								;
	xor		ecx, [eax]			;
	add		eax, 4				;              
	add		ecx, 0FEFEFEFFh		;   
    test	ecx, 080808080h		;   
	mov		ecx, edx			; edx=77 77 77 77h  ; 77h -> ASCII code of "w"
  	je		@b					; 
								;
    cmp		[eax-4], dl			; dl ->1st byte of pattern
    lea		eax, [eax-3]	
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]	
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]
	jne		@b
@@:								; CMP rest  of strings
	add		bl,	 [esi]
	je		@found	
	sub		bl,	 [eax]
	jne		BytesScan
	add		bl,	 [esi+1]
	je		@found	
	sub		bl,	 [eax+1]
	jne		BytesScan
	add		bl,	 [esi+2]
	je		@found	
	sub		bl,	 [eax+2]
	jne		BytesScan
	add		bl,	 [esi+3]
	je		@found	
	sub		bl,	 [eax+3]
	jne		BytesScan	
	add		bl,	 [esi+4]
	je		@found	
	sub		bl,	 [eax+4]
	jne		BytesScan
	add		bl,	 [esi+5]
	je		@found	
	sub		bl,	 [eax+5]
	jne		BytesScan
	add		bl,	 [esi+6]
	je		@found	
	sub		bl,	 [eax+6]
	jne		BytesScan
	add		bl,	 [esi+7]
	je		@found	
	sub		bl,	 [eax+7]
	jne		BytesScan
	add		bl,	 [esi+8]
	je		@found	
	sub		bl,	 [eax+8]
	jne		BytesScan
	mov		edx, 8
@@:	
	add		bl,	 [esi+edx+1]
	je		@found	
	sub		bl,	 [eax+edx+1]
	jne		BytesScan
	add		bl,	 [esi+edx+2]
	je		@found	
	sub		bl,	 [eax+edx+2]
	jne		BytesScan
	add		bl,	 [esi+edx+3]
	je		@found	
	sub		bl,	 [eax+edx+3]
	jne		BytesScan
	add		bl,	 [esi+edx+4]
	je		@found	
	sub		bl,	 [eax+edx+4]
	jne		BytesScan
	add		edx, 4
	jne		@b
@found:	
	mov		ebx, [esp+1*4]	 
	cmp		eax, esi		
	mov		esi, [esp+2*4]	 
	sbb		ecx, ecx
	mov		edx, [esp]	 
	add		eax,  -1		
	add		esp, 3*4 
	and		eax, ecx		;eax-> address of 1st occurrence or 0->Not found   
	jmp		edx				;
InStringL	endp			;
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

finstr proc spos:DWORD,psrc:DWORD,patn:DWORD

    .data?
      align 16
      _ebx dd ?
      _esi dd ?
      _edi dd ?
      _ebp dd ?
    .code

    mov _ebx, ebx
    mov _esi, esi
    mov _edi, edi
    mov _ebp, ebp

    mov ebp, 1
    mov edi, [esp+12]               ; patn
    movzx eax, BYTE PTR [edi]       ; set 1st patn byte in AL
    mov esi, [esp+8]                ; psrc
    add esi, [esp+4]                ; spos
    sub esi, ebp

; --------------------

  align 16
  scanloop:
  REPEAT 15
    add esi, ebp
    movzx edx, BYTE PTR [esi]
    cmp eax, edx
    je prematch
    test edx, edx                   ; test for source terminator
    jz no_match
  ENDM

    add esi, ebp
    movzx edx, BYTE PTR [esi]
    cmp eax, edx
    je prematch
    test edx, edx                   ; test for source terminator
    jnz scanloop
    jmp no_match

; --------------------

  align 16
  prematch:
    xor ebx, ebx

; --------------------

  matchloop:
  REPEAT 7
    add ebx, ebp
    movzx ecx, BYTE PTR [esi+ebx]
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match
    cmp ecx, edx
    jne scanloop
  ENDM

    add ebx, ebp
    movzx ecx, BYTE PTR [esi+ebx]
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match
    cmp ecx, edx
    jne scanloop
    jmp matchloop

; --------------------

  match:
    sub esi, [esp+8]                ; psrc
    mov eax, esi
    jmp cleanup

  no_match:
    xor eax, eax

  cleanup:
    mov ebx, _ebx
    mov esi, _esi
    mov edi, _edi
    mov ebp, _ebp

    ret 12

finstr endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; ##############################################
align 16

InstrCi proc uses edi lpSource:DWORD, lpPattern:DWORD
  mov eax, lpSource
  mov edx, lpPattern
  mov edx, [edx]
; mov edi, 20202020h	; lowercase bit mask for finding "TEST" in "This is a Test"
  mov edi, 20h			; lowercase bit mask for finding "test" and "Test" but not "TEST" in "This is a Test"
  or edx, edi			; make pattern lowercase
@@:	mov ecx, [eax]
	test cl, cl		; source end?
	jz @F
	or ecx, edi		; make source lowercase
	add eax, 1		; inc eax would cost around 5%
	cmp ecx, edx
	jne @B
  dec eax
  ret
@@:
  xor eax, eax
  ret
InstrCi endp

; ##############################################

end start
OPT_SUSY	CONSOLE
OPT_DelTmp	0
